
/********************************************************************
 * C Users Group (U.K) C Source Code Library File CUGLIB.002        *
 * Inquiries to: M. Houston, 36 Whetstone Clo. Farquhar Rd.         *
 * Edgbaston, Birmingham B15 2QN ENGLAND			    *
 ********************************************************************
 * File name: adshell.c
 * Program name: adshell
 * Source of file: Martin Houston
 * Purpose: Just some ideas for an adventure parser - mostly to
 * demonstrate the use of function pointers.
 * Changes: <who what when & why major changes have been made>      
 ********************************************************************/
/*
 * Adventure parser shell code file.
 * By Martin Houstion for CUG(UK)
 * 25/5/86
 */

#include <ctype.h>
#include "adshell.h"

#define SAME(A,B) (!strcmp(A,B))
#define TRUE 1
#define FALSE !(TRUE)
#define NULL  (char *)0


int parse(line, tab)
char *line;
struct look_up_func tab[];	/* array of structs */
{
	int acted = FALSE;	/* we have not done anything yet */

	static int wordstarts[LINELEN/2];
	/*
	 * As each word is seperated from the next by 
	 * whitespace there can only be at most LINELEN / 2
	 */

	static char words[LINELEN/2][WORDLEN];

	int slot;	/* slot in table */
	int lindex;	/* maximum used slot in table */
	int cn;		/* character counter */
	int x;		/* dogsbody variable ! */
	char *str;	/* input string */
	char c;		/* next character */

	int fpslot;
	struct look_up_func *fp;

	char between_words;

	/*
	 * Build up tables of words and word starts
	 */
	str = line;
	between_words = TRUE;
	for(lindex=0, slot=0, cn=0; lindex<LINELEN; lindex++)
	{

		if(((c = *str++) == '\0') || isspace(c))
		{
			if(cn > 0)
                        {
				/* terminated a word */
				strncpy(words[slot],
					&line[wordstarts[slot]], cn);
				words[slot][cn] = '\0';
				cn = 0;
				slot++;
			}
			between_words = TRUE;
			if(c == '\0')
			{
				break; /* no more input line */
			}

		}
		else
		{
			if(between_words)
			{
				/* started a word */
				wordstarts[slot] = lindex;
				between_words = FALSE;
			}
			if(cn < WORDLEN)
				cn++; /* count a character */
		}
	}


	/* now try to find a match */
	for(x=0; x < slot; )
	{
		fpslot = 0;

		while((fp = &tab[fpslot++]) != NULL)
		{
			if(SAME(words[x], fp->token))
			{
				acted = TRUE;
				x += (*fp->action)(line,wordstarts[x]);
				if(x < 0)
					x = 0;
				break;
			}
			if(SAME(fp->token, ""))
				break;
		}
		/* if no match was found above ignore this word */
		if(SAME(fp->token, ""))
			x++;
	}
	return acted;
}

